// 这个接口页面，主要处理微信相关的接口
const _request = require('request')
const sha1 = require('sha1')
const _config = {
  'weixinsecret': {
    'wxd6109d07f6396e5c': 'd80a330735fc82f3fd6aba425481e8fd',
    'wxe1849e28e176c67b': '90072420a6b6941b7b8af38afd019b9f',
    'wx451c01d40d090d7a': 'c740445d23458904dd7cc8f2e1bc2601',
    'wxb0280dd47666d2e9': 'f5f6e01dfa06da3a29b7fa710a287073'
  }
}
let share_json = { // eslint-disable-line
  jsapi_ticket: '', // 上一步获取的 ticket
  noncestr: '', // 随机字符串
  timestamp: '' // 事件戳
}

// 获取token
function getsignature (req, res) {
  let access_token_url = 'https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential' // eslint-disable-line
  let jsapi_ticket_url = 'https://api.weixin.qq.com/cgi-bin/ticket/getticket?type=jsapi&access_token=' // eslint-disable-line

  let get_access_token_url = access_token_url + '&appid=' + req.body.appId + '&secret=' + _config.weixinsecret[req.body.appId] // eslint-disable-line

  new Promise((resolve, reject) => {
    return _request.get(get_access_token_url, function (error, response, body) {
      return error ? reject(error) : resolve(body)
    })
  }).then((newResult) => {
    let url = jsapi_ticket_url + JSON.parse(newResult).access_token // eslint-disable-line
    // 获取 ticket
    return new Promise((resolve, reject) => {
      _request.get(url, function (err, rs, body) {
        share_json.jsapi_ticket = JSON.parse(body).ticket
        share_json.noncestr = Math.random().toString(36).substr(2, 15) // 随机字符串
        share_json.timestamp = parseInt(new Date().getTime() / 1000) + '' // 事件戳

        let str1 = 'jsapi_ticket=' + share_json.jsapi_ticket + '&noncestr=' + share_json.noncestr + '&timestamp=' + share_json.timestamp + '&url=' + req.headers.referer
        let token = sha1(str1)
        return err ? reject(err) : res.send({
          token: token, // 上一步获取的 ticket
          noncestr: share_json.noncestr, // 随机字符串
          timestamp: share_json.timestamp
        })
      })
    })
  })
    .catch(function (e) {
      console.log('有错误')
    })
}

// 获取token后分享
const wxGetsignature = function (req, res) {
  getsignature(req, res)
}

// 微信分享
const wxShare = function (req, res) {
  if (share_json.jsapi_ticket) {
    let str1 = 'jsapi_ticket=' + share_json.jsapi_ticket + '&noncestr=' + share_json.noncestr + '&timestamp=' + share_json.timestamp + '&url=' + req.headers.referer
    let token = sha1(str1)
    return res.send({
      token: token, // 上一步获取的 ticket
      noncestr: share_json.noncestr, // 随机字符串
      timestamp: share_json.timestamp
    })
  } else {
    getsignature(req, res)
  }
}
// 获取用户信息
const wxGetInfo = function (req, res) {
  let access_token_url = 'https://api.weixin.qq.com/sns/oauth2/access_token?' // eslint-disable-line
  let get_userInfo_url = 'https://api.weixin.qq.com/sns/userinfo?' // eslint-disable-line

  let get_access_token_url = access_token_url + 'appid=' + req.body.appId + '&secret=' + _config.weixinsecret[req.body.appId] + '&code=' + req.body.code + '&grant_type=authorization_code' // eslint-disable-line

  new Promise((resolve, reject) => {
    return _request.get(get_access_token_url, function (error, response, body) {
      return error ? reject(error) : resolve(body)
    })
  }).then((newResult) => {
    if (JSON.parse(newResult).errmsg) { res.send({ err: '授权获取信息失败', errmsg: JSON.parse(newResult).errmsg }); return }

    let url = get_userInfo_url + 'access_token=' + JSON.parse(newResult).access_token + '&openid=' + JSON.parse(newResult).openid + '&lang=zh_CN' // eslint-disable-line
    // 获取 ticket
    return new Promise((resolve, reject) => {
      _request.get(url, function (err, rs, body) {
        if (JSON.parse(body).errmsg) { res.send({ err: '获取信息失败', errmsg: JSON.parse(newResult).errmsg }); return }
        return err ? reject(err) : res.send(JSON.parse(body))
      })
    })
  }).catch(function (e) {
    console.log('有错误')
  })
}

module.exports = {
  wxGetsignature,
  wxShare,
  wxGetInfo
}
